use schoolcal3, clear

list study stdmdiff se if _n < 5 | _n > 52, sep(0) ab(20)

meta set stdmdiff se 
meta summarize, nostudies
meta forestplot in 1/10

describe
list district school study stdmdiff mean_exp in 1/11, sepby(district)

meta multilevel stdmdiff, relevels(district school) ///
 essevariable(se) nolog

estat heterogeneity 

meta multilevel stdmdiff, relevels(district school) essevariable(se) 
estimates store full_model
meta multilevel stdmdiff, relevels(study) essevariable(se) nolog
estimates store standard_model

lrtest full_model standard_model

meta multilevel stdmdiff, relevels(district) essevariable(se) nolog
estimates store district_re

lrtest full_model district_re

estimates stats full_model district_re standard_model, n(55)

etable, estimates(full_model district_re standard_model)

etable, estimates(full_model district_re standard_model) ///
 equations(stdmdiff district school) showeq ///
 mstat(N) mstat(aic) mstat(bic) column(index) ///
 export(mytable.docx)

estimates clear

quietly meta multilevel stdmdiff, ///
 relevels(district school, sd(. 0.01)) essevariable(se)
estimates store fixsd1 

quietly meta multilevel stdmdiff, ///
 relevels(district school, sd(. 0.18)) essevariable(se)
estimates store fixsd2

quietly meta multilevel stdmdiff, ///
 relevels(district school, sd(. 0.6)) essevariable(se)
estimates store fixsd3 

estimates table _all, stats(sd2) keep(stdmdiff:_cons) ///
 b(%8.3f) se(%8.3f)

estimates table _all, stats(sd2) keep(lns1_1_1:_cons) ///
 b(%8.3f) eform 

meta multilevel stdmdiff, relevels(district school, sd(. 0.01)) ///
 essevariable(se) nogroup nolog noheader nofetable 
matrix list e(b)
display exp(-1.2460597)

qui: meta multilevel stdmdiff, relevels(district school) esse(se)
predict double u3 u2, reffects reses(se_u3 se_u2, diagnostic)
by district, sort: generate tolist = (_n==1)
list district u3 se_u3 if tolist

generate double ustan3 = u3/se_u3
label variable ustan3 "Std. predicted random effects u3"
qnorm ustan3 if tolist, mlabel(district) xtitle("Inverse normal")


meta meregress stdmdiff mean_exp ///
 || district: mean_exp ///
 || school:, essevariable(se) nolog nogroup

estat sd, variance

predict double fit, fitted 

twoway (scatter fit stdmdiff) ///
 (function y = x, range(stdmdiff)), ///
 legend(off) xtitle(Observed values) ytitle(Fitted values)

meta meregress stdmdiff mean_exp ///
 || district: mean_exp, covariance(exchangeable) ///
 || school:, essevariable(se) nolog nogroup 
 
meta meregress stdmdiff mean_exp class_size ///
 || district: mean_exp class_size, covariance(exchangeable) ///
 || school:, essevariable(se) var matlog nolog nogroup noheader

estat recovariance 

